Index: s390-tools-sles11/ziomon/ziorep_framer.cpp
===================================================================
--- /dev/null
+++ s390-tools-sles11/ziomon/ziorep_framer.cpp
@@ -0,0 +1,288 @@
+/*
+ * FCP report generators
+ *
+ * Class for reading messages into frames.
+ *
+ * Copyright IBM Corp. 2008
+ * Author(s): Stefan Raspl <raspl@linux.vnet.ibm.com>
+ */
+
+#include <assert.h>
+#include <unistd.h>
+#define __STDC_LIMIT_MACROS
+#include <stdint.h>
+#include <stdlib.h>
+
+#include "ziorep_framer.hpp"
+#include "ziorep_utils.hpp"
+
+extern "C" {
+#include "ziomon_msg_tools.h"
+}
+
+extern const char *toolname;
+extern int verbose;
+
+
+Framer::Framer(__u64 begin, __u64 end, __u32 interval_length,
+	       list<MsgTypes> *filter_types, DeviceFilter *devFilter,
+	       const char *filename, int *rc)
+	: m_interval_length(interval_length), m_type_filter(NULL),
+	m_device_filter(devFilter), m_filename(filename), m_fp(NULL),
+	m_agg_read(false)
+{
+	m_begin = begin;
+	m_end = end;
+	assert(m_begin <= m_end);
+
+	// set up .log file on first time
+	if (open_data_files(&m_fp, m_filename, &m_fhdr, &m_agg_data)) {
+		*rc = -2;
+		return;
+	}
+	if (m_agg_data)
+		conv_aggr_data_msg_data_from_BE(m_agg_data);
+
+	time_t t = m_begin;
+	t = m_end;
+
+	if (filter_types) {
+		m_type_filter = new MsgTypeFilter;
+		for (list<MsgTypes>::const_iterator i = filter_types->begin();
+		      i != filter_types->end(); ++i) {
+			switch (*i) {
+			case utilization:
+				m_type_filter->add_type(m_fhdr.msgid_utilization);
+				break;
+			case ioerr:
+				m_type_filter->add_type(m_fhdr.msgid_ioerr);
+				break;
+			case blkiomon:
+				m_type_filter->add_type(m_fhdr.msgid_blkiomon);
+				break;
+			case zfcpdd:
+				m_type_filter->add_type(m_fhdr.msgid_zfcpdd);
+				break;
+			}
+		}
+	}
+
+	*rc = 0;
+}
+
+Framer::~Framer()
+{
+	close_data_files(m_fp);
+
+	if (m_type_filter)
+		delete m_type_filter;
+
+	if (m_agg_data) {
+		discard_aggr_data_struct(m_agg_data);
+		free(m_agg_data);
+	}
+}
+
+bool Framer::handle_agg_data(Frameset &frameset) const
+{
+	// Initial test - if we pass, we still have to check
+	// the messages individually later on!
+	if (m_begin > m_agg_data->end_time || m_end < m_agg_data->begin_time)
+		return false;
+
+	/* collate all messages */
+	list<struct message *> agg_msgs;
+	if (m_agg_data->util_aggr)
+		agg_msgs.insert(agg_msgs.end(), m_agg_data->util_aggr);
+	if (m_agg_data->ioerr_aggr)
+		agg_msgs.insert(agg_msgs.end(), m_agg_data->ioerr_aggr);
+	for (unsigned int i = 0; i<m_agg_data->num_blkiomon; ++i)
+		agg_msgs.insert(agg_msgs.end(), m_agg_data->blkio_aggr[i]);
+	for (unsigned int i = 0; i<m_agg_data->num_zfcpdd; ++i)
+		agg_msgs.insert(agg_msgs.end(), m_agg_data->zfcpdd_aggr[i]);
+
+	/* loop over collated msgs */
+	for (list<struct message*>::iterator i=agg_msgs.begin();
+	      i != agg_msgs.end(); ++i) {
+		// we do an all-or-nothing approach - anything else would be
+		// too confusing
+		/*
+		__u64 t = get_timestamp_from_msg(*i);
+		if (m_begin > t || m_end < t) {
+			vverbose_msg("message not in timeframe\n");
+			continue;
+		} */
+		if (m_type_filter && !m_type_filter->is_eligible(*i)) {
+			vverbose_msg("message type not eligible\n");
+			continue;
+		}
+		vverbose_msg("adding msg\n");
+		handle_msg(*i, frameset);
+	}
+	verbose_msg("    found eligible data in aggregated messages: %d\n",
+		    frameset.is_aggregated());
+
+	return (!frameset.is_empty());
+}
+
+void Framer::handle_msg(struct message *msg, Frameset &frameset) const
+{
+	if (msg->type == m_fhdr.msgid_utilization) {
+		struct utilization_data *res = (struct utilization_data*)msg->data;
+		struct adapter_utilization *a_res;
+		for (int i = 0; i < res->num_adapters; ++i) {
+			a_res = &res->adapt_utils[i];
+			if (m_device_filter && !m_device_filter->is_eligible(a_res)) {
+				vverbose_msg("message not for eligible device\n");
+				continue;
+			}
+			vverbose_msg("adding utilization msg\n");
+			frameset.add_data(a_res);
+		}
+	}
+	else if (msg->type == m_fhdr.msgid_ioerr) {
+		struct ioerr_data *data = (struct ioerr_data*)msg->data;
+		struct ioerr_cnt *cnt;
+		for (unsigned int i = 0; i < data->num_luns; ++i) {
+			cnt = &data->ioerrors[i];
+			if (m_device_filter && !m_device_filter->is_eligible(cnt)) {
+				vverbose_msg("message not for eligible device\n");
+				continue;
+			}
+			vverbose_msg("adding ioerr msg\n");
+			frameset.add_data(cnt);
+		}
+	}
+	else {
+		if (m_device_filter && !m_device_filter->is_eligible(msg, &m_fhdr)) {
+			vverbose_msg("message not for eligible device\n");
+			return;
+		}
+		if (msg->type == m_fhdr.msgid_blkiomon) {
+			vverbose_msg("adding blkiomon msg\n");
+			frameset.add_data((struct blkiomon_stat*)msg->data);
+		}
+		else {
+			assert(msg->type == m_fhdr.msgid_zfcpdd);
+			vverbose_msg("adding zfcpdd msg\n");
+			frameset.add_data((struct zfcpdd_dstat*)msg->data);
+		}
+	}
+}
+
+int Framer::get_next_frameset(Frameset &frameset, bool replace_missing)
+{
+	int rc = 0;
+	int msgs_read = 0;
+	__u64 shifted_begin;
+	__u64 shifted_end;
+	__u64 frame_begin = 0;
+
+	frameset.reinit();
+
+	if (m_begin > m_end)
+		return 1;
+
+	if (verbose >= 2) {
+#ifndef NDEBUG
+		time_t t = m_begin;
+#endif
+		vverbose_msg("retrieving next frameset for: %s", ctime(&t));
+	}
+
+	// did we check out .agg yet?
+	if (!m_agg_read) {
+		m_agg_read = true;
+		if (m_agg_data) {
+			verbose_msg("    found aggregated data, check if eligible\n");
+			handle_agg_data(frameset);
+			if (!frameset.is_empty()) {
+				if (m_interval_length != 0) {
+					verbose_msg(".agg data processed, wrap up frame\n");
+					frameset.set_aggregated(true);
+					frameset.set_timeframe(
+						m_agg_data->begin_time
+							- m_fhdr.interval_length / 2,
+						m_agg_data->end_time
+							+ m_fhdr.interval_length / 2,
+						m_agg_data->end_time);
+					// just bump it to the next frame
+					m_begin += m_fhdr.interval_length;
+					if (replace_missing)
+						frameset.replace_missing_datasets(m_fhdr.interval_length);
+
+					return 0;
+				}
+				verbose_msg(".agg data processed, add all of the rest to it\n");
+				frame_begin = m_agg_data->begin_time - m_fhdr.interval_length / 2;
+			}
+		}
+		else
+			verbose_msg("    no aggregated data found\n");
+	}
+
+	// down to real business
+	struct message		msg;
+	struct message_preview	msg_preview;
+
+	shifted_begin = m_begin - m_fhdr.interval_length / 2;
+	shifted_end = shifted_begin + m_interval_length;
+	if (m_interval_length == 0 || shifted_end > m_end)
+		shifted_end = m_end + m_fhdr.interval_length / 2;
+	MsgTimeFilter timeFilter(shifted_begin, shifted_end);
+
+	if (frame_begin == 0)
+		frame_begin = timeFilter.get_begin_time();
+
+	while( (rc = get_next_msg_preview(m_fp, &msg_preview, &m_fhdr)) == 0 ) {
+		vverbose_msg("checking out next msg\n");
+		++msgs_read;
+		if (msg_preview.timestamp > timeFilter.get_end_time()) {
+			vverbose_msg("timeframe exceeded\n");
+			rewind_to(m_fp, &msg_preview);
+			break;
+		}
+		// is this necessary at all?!?
+		if (!timeFilter.is_eligible(&msg_preview))
+			continue;
+		vverbose_msg("timestamp: OK\n");
+		if (m_type_filter && !m_type_filter->is_eligible(&msg_preview)) {
+			vverbose_msg("wrong type (%u)\n", msg_preview.type);
+			continue;
+		}
+		vverbose_msg("type     : OK\n");
+		if (get_complete_msg(m_fp, &msg_preview, &msg) < 0) {
+			fprintf(stderr, "%s: Error retrieving next message, aborting"
+				" - file corrupt?\n", toolname);
+			return -5;
+		}
+		conv_msg_data_from_BE(&msg, &m_fhdr);
+		handle_msg(&msg, frameset);
+		discard_msg(&msg);
+	}
+
+	if (rc < 0) {
+		fprintf(stderr, "%s: Error retrieving next message, aborting"
+			" - file corrupt?\n", toolname);
+		return -4;
+	}
+
+	/* if we read some messages, though not the right ones,
+	   we pass on an empty frame still. Will indicate EOF next time */
+	if (rc > 0 && msgs_read)
+		rc = 0;
+
+	if (rc == 0) {
+		frameset.set_timeframe(frame_begin, timeFilter.get_end_time(),
+                              timeFilter.get_end_time() - m_fhdr.interval_length / 2);
+		if (m_interval_length == 0)
+			m_begin = m_end + 1;	// we're done
+		else
+			m_begin += m_interval_length;
+		if (replace_missing)
+			frameset.replace_missing_datasets(m_fhdr.interval_length);
+	}
+
+	return rc;
+}
+
Index: s390-tools-sles11/ziomon/ziorep_framer.hpp
===================================================================
--- /dev/null
+++ s390-tools-sles11/ziomon/ziorep_framer.hpp
@@ -0,0 +1,79 @@
+/*
+ * FCP report generators
+ *
+ * Class for reading messages into frames.
+ *
+ * Copyright IBM Corp. 2008
+ * Author(s): Stefan Raspl <raspl@linux.vnet.ibm.com>
+ */
+
+#ifndef ZIOREP_FRAMER
+#define ZIOREP_FRAMER
+
+#include <list>
+
+#include "ziorep_filters.hpp"
+#include "ziorep_frameset.hpp"
+
+
+using std::list;
+
+
+extern "C" {
+#include "ziomon_dacc.h"
+}
+
+
+class Framer {
+public:
+	/**
+	 * Note: Filter parameters transfer memory ownership to class.
+	 * 'filter_types' is an optional list of message types that should
+	 * be processed exclusively, anything else will be ignored. If not set,
+	 * all messages will be processed.
+	 */
+	Framer(__u64 begin, __u64 end, __u32 interval_length,
+	       list<MsgTypes> *filter_types, DeviceFilter *devFilter,
+	       const char *filename, int *rc);
+
+	~Framer();
+
+	/**
+	 * Retrieve the next set of messages.
+	 * Returns 0 in case of success, <0 in case of failure
+	 * and >0 in case end of data has been reached.
+	 * Set 'replace_missing' to fill in for non-present datasets.
+	 * E.g. if no utilization data was found in the interval (since there
+	 * was no traffic), a dataset with the expected number of samples
+	 * (but all 0s for the values) will be generated.
+	 */
+	int get_next_frameset(Frameset &frameset, bool replace_missing = false);
+
+private:
+	void handle_msg(struct message *msg, Frameset &frameset) const;
+	bool handle_agg_data(Frameset &frameset) const;
+
+	/* timestamps of samples to consider
+	 * These are exact timestamps, we shift them a bit to make sure that
+	 * we catch any late or early messages as well */
+	__u64		 	 m_begin;
+	__u64		 	 m_end;
+	/// user-specified interval length
+	__u32		 	 m_interval_length;
+
+	/* Criteria to identify the right messages */
+	MsgTypeFilter		*m_type_filter;
+	DeviceFilter		*m_device_filter;
+
+	// filename without extension
+	const char		*m_filename;
+	FILE			*m_fp;
+	struct file_header	 m_fhdr;
+	struct aggr_data	*m_agg_data;
+	/// indicates whether the .agg file was already read or not
+	bool			 m_agg_read;
+};
+
+
+#endif
+
Index: s390-tools-sles11/ziomon/ziorep_frameset.cpp
===================================================================
--- /dev/null
+++ s390-tools-sles11/ziomon/ziorep_frameset.cpp
@@ -0,0 +1,607 @@
+/*
+ * FCP report generators
+ *
+ * Class to hold information of a single frame.
+ *
+ * Copyright IBM Corp. 2008
+ * Author(s): Stefan Raspl <raspl@linux.vnet.ibm.com>
+ */
+
+#include <assert.h>
+
+#include "ziorep_frameset.hpp"
+
+extern "C" {
+	#include "ziomon_tools.h"
+}
+
+extern const char *toolname;
+extern int verbose;
+
+
+Frameset::Frameset(const Collapser *col, bool normalize) :
+m_empty(true), m_aggregated(false),
+	m_collapser(col), m_normalize(normalize)
+{
+	reinit();
+
+	/* We set everything up for aggregation collapsers */
+	if (m_collapser->get_criterion() != none
+	    && m_collapser->get_criterion() != all) {
+		unsigned int len = 0;
+
+		AggregationCollapser *col = (AggregationCollapser*)m_collapser;
+		switch (m_collapser->get_criterion()) {
+		case chpid: len = col->get_reference_chpids().size();
+			break;
+		case devno: len = col->get_reference_devnos().size();
+			break;
+		case wwpn: len = col->get_reference_wwpns().size();
+			break;
+		case multipath_device: len = col->get_reference_mp_mms().size();
+			break;
+		default:
+			assert(false);
+		}
+		m_util_stats.resize(len);
+		m_ioerr_stats.resize(len);
+		m_blkiomon_stats.resize(len);
+		m_zfcpdd_stats.resize(len);
+		for (unsigned int i = 0; i < len; ++i) {
+			init_utilization_wrapper(&m_util_stats[i]);
+			m_ioerr_stats[i] = NULL;
+			m_blkiomon_stats[i] = NULL;
+			init_zfcpdd_wrapper(&m_zfcpdd_stats[i]);
+		}
+	}
+}
+
+Frameset::~Frameset()
+{
+	reinit();
+}
+
+void Frameset::reinit()
+{
+	for (vector<struct utilization_wrapper>::iterator i=m_util_stats.begin();
+	      i != m_util_stats.end(); i++) {
+		delete (*i).stat;
+		init_utilization_wrapper(&(*i));
+	}
+
+	for (vector<struct ioerr_cnt*>::iterator i=m_ioerr_stats.begin();
+	      i != m_ioerr_stats.end(); i++) {
+		delete *i;
+		*i = NULL;
+	}
+
+	for (vector<struct zfcpdd_wrapper>::iterator i=m_zfcpdd_stats.begin();
+	      i != m_zfcpdd_stats.end(); i++) {
+		delete (*i).stat;
+		init_zfcpdd_wrapper(&(*i));
+	}
+
+	for (vector<struct blkiomon_stat*>::iterator i=m_blkiomon_stats.begin();
+	      i != m_blkiomon_stats.end(); i++) {
+		delete *i;
+		*i = NULL;
+	}
+
+	if (m_collapser->get_criterion() == none
+		|| m_collapser->get_criterion() == all) {
+		m_util_stats.clear();
+		m_ioerr_stats.clear();
+		m_zfcpdd_stats.clear();
+		m_blkiomon_stats.clear();
+	}
+
+	m_aggregated = false;
+	m_start_time = 0;
+	m_end_time = 0;
+	m_empty = true;
+	m_timestamp = 0;
+}
+
+const Collapser* Frameset::get_collapser() const
+{
+	return m_collapser;
+}
+
+
+void Frameset::add_zero_frames(struct utilization_wrapper *wrp,
+			     int num_expected, int interval_length)
+{
+	// found a (probable) kernel bug that cause a violation of this
+	// assertion. There might be other reasons (exzessive steal times)
+	// that could cause a violation as well.
+	//assert(!wrp || wrp->counter <= num_expected);
+
+	if (wrp
+	    && wrp->counter > 0
+	    && wrp->counter < num_expected
+	    && wrp->stat->valid) {
+		vverbose_msg("Correcting util stat from %d to %d datasets\n",
+			     wrp->counter, num_expected);
+		transform_abbrev_stat(&wrp->stat->stats.adapter,
+				  wrp->stat->stats.count,
+				  wrp->counter);
+		transform_abbrev_stat(&wrp->stat->stats.bus,
+				  wrp->stat->stats.count,
+				  wrp->counter);
+		transform_abbrev_stat(&wrp->stat->stats.cpu,
+				  wrp->stat->stats.count,
+				  wrp->counter);
+		wrp->stat->stats.queue_util_interval += interval_length * 1000000
+				* (num_expected - wrp->counter);
+		wrp->stat->stats.count = num_expected;
+		wrp->counter = num_expected;
+	}
+}
+
+
+/**
+ * Only fix utilization and the qdio portion of util
+ * datasets - the rest doesn't matter */
+void Frameset::replace_missing_datasets(int interval_length)
+{
+	int num_expected_datasets;
+
+	assert(m_start_time != 0);
+	assert(m_end_time != 0);
+	assert(interval_length > 0);
+
+	num_expected_datasets = (m_end_time - m_start_time) /interval_length;
+	for (vector<struct utilization_wrapper>::iterator i = m_util_stats.begin();
+	      i != m_util_stats.end(); ++i)
+		add_zero_frames(&(*i), num_expected_datasets, interval_length);
+}
+
+void Frameset::set_timeframe(__u64 begin, __u64 end, __u64 timestamp)
+{
+	m_start_time = begin;
+	m_end_time = end;
+	m_timestamp = timestamp;
+}
+
+__u64 Frameset::get_begin_time() const
+{
+	return m_start_time;
+}
+
+__u64 Frameset::get_end_time() const
+{
+	return m_end_time;
+}
+
+__u64 Frameset::get_timestamp() const
+{
+	return m_timestamp;
+}
+
+__u64 Frameset::get_duration() const
+{
+	return (m_end_time - m_start_time);
+}
+
+
+void Frameset::normalize_stat(struct abbrev_stat *stat, __u64 count)
+{
+	stat->sum = (__u64)calc_avg(stat->sum, count);
+	stat->sos = (__u64)calc_avg(stat->sos, count);
+}
+
+
+void Frameset::normalize_util_stat(struct utilization_stats *stats)
+{
+	if (stats->count > 1) {
+		normalize_stat(&stats->adapter, stats->count);
+		normalize_stat(&stats->bus, stats->count);
+		normalize_stat(&stats->cpu, stats->count);
+		stats->count = 1;
+	}
+}
+
+
+void Frameset::add_data(struct adapter_utilization *res)
+{
+	unsigned int idx = m_collapser->get_index_by_host_id(res->adapter_no);
+
+	m_empty = false;
+
+	if (idx >= m_util_stats.size()) {
+		unsigned int old_size = m_util_stats.size();
+		m_util_stats.resize(idx + 1);
+		for (unsigned int i = old_size; i < idx + 1; ++i)
+			init_utilization_wrapper(&m_util_stats[i]);
+	}
+
+	if (m_normalize)
+		normalize_util_stat(&res->stats);
+
+	if (m_util_stats[idx].counter) {
+		aggregate_adapter_result(res, m_util_stats[idx].stat);
+		m_util_stats[idx].counter++;
+	}
+	else {
+		m_util_stats[idx].stat = new struct adapter_utilization;
+		*m_util_stats[idx].stat = *res;
+		m_util_stats[idx].counter = 1;
+	}
+}
+
+
+void Frameset::add_data(struct ioerr_cnt *cnt)
+{
+	unsigned int idx = m_collapser->get_index(&cnt->identifier);
+
+	m_empty = false;
+
+	if (idx >= m_ioerr_stats.size()) {
+		unsigned int old_size = m_ioerr_stats.size();
+		m_ioerr_stats.resize(idx + 1);
+		for (unsigned int i = old_size; i < idx + 1; ++i)
+			m_ioerr_stats[i] = NULL;
+	}
+
+	if (m_ioerr_stats[idx])
+		aggregate_ioerr_cnt(cnt, m_ioerr_stats[idx]);
+	else {
+		m_ioerr_stats[idx] = new struct ioerr_cnt;
+		*m_ioerr_stats[idx] = *cnt;
+	}
+}
+
+
+void Frameset::add_data(struct blkiomon_stat *stat)
+{
+	unsigned int idx = m_collapser->get_index(stat->device);
+
+	m_empty = false;
+
+	if (idx >= m_blkiomon_stats.size()) {
+		unsigned int old_size = m_blkiomon_stats.size();
+		m_blkiomon_stats.resize(idx + 1);
+		for (unsigned int i = old_size; i < idx + 1; ++i)
+			m_blkiomon_stats[i] = NULL;
+	}
+
+	if (m_blkiomon_stats[idx])
+		blkiomon_stat_merge(m_blkiomon_stats[idx], stat);
+	else {
+		m_blkiomon_stats[idx] = new struct blkiomon_stat;
+		*m_blkiomon_stats[idx] = *stat;
+	}
+}
+
+
+void Frameset::normalize_zfcpdd_stat(struct zfcpdd_dstat *stat)
+{
+	stat->chan_lat.min /= 1000;
+	stat->chan_lat.max /= 1000;
+	stat->chan_lat.sum /= 1000;
+	stat->chan_lat.sos /= (1000 * 1000);
+}
+
+
+void Frameset::add_data(struct zfcpdd_dstat *stat)
+{
+	unsigned int idx = m_collapser->get_index(stat->device);
+
+	m_empty = false;
+
+	normalize_zfcpdd_stat(stat);
+
+	if (idx >= m_zfcpdd_stats.size()) {
+		unsigned int old_size = m_zfcpdd_stats.size();
+		m_zfcpdd_stats.resize(idx + 1);
+		for (unsigned int i = old_size; i < idx + 1; ++i)
+			init_zfcpdd_wrapper(&m_zfcpdd_stats[i]);
+	}
+
+	if (m_zfcpdd_stats[idx].counter) {
+		aggregate_dstat(stat, m_zfcpdd_stats[idx].stat);
+		m_zfcpdd_stats[idx].counter++;
+	}
+	else {
+		m_zfcpdd_stats[idx].stat = new struct zfcpdd_dstat;
+		*m_zfcpdd_stats[idx].stat = *stat;
+		m_zfcpdd_stats[idx].counter = 1;
+	}
+}
+
+void Frameset::set_aggregated(bool aggr)
+{
+	m_aggregated = aggr;
+}
+
+bool Frameset::is_aggregated() const
+{
+	return m_aggregated;
+}
+
+bool Frameset::is_empty() const
+{
+	return m_empty;
+}
+
+const vector<struct ioerr_cnt*>& Frameset::get_ioerr_stats() const
+{
+	return m_ioerr_stats;
+}
+
+const struct zfcpdd_dstat* Frameset::get_first_zfcpdd_stat() const
+{
+	assert(m_zfcpdd_stats.size() <= 1);
+
+	if (m_zfcpdd_stats.size() > 0)
+		return m_zfcpdd_stats[0].stat;
+	else
+		return NULL;
+}
+
+const struct blkiomon_stat* Frameset::get_first_blkiomon_stat() const
+{
+	assert(m_blkiomon_stats.size() <= 1);
+
+	if (m_blkiomon_stats.size() > 0)
+                return m_blkiomon_stats[0];
+	else
+		return NULL;
+}
+
+void Frameset::init_utilization_wrapper(struct utilization_wrapper *wrp)
+{
+	wrp->counter = 0;
+	wrp->stat = NULL;
+}
+
+void Frameset::init_zfcpdd_wrapper(struct zfcpdd_wrapper *wrp)
+{
+	wrp->counter = 0;
+	wrp->stat = NULL;
+}
+
+int Frameset::get_by_chpid(__u32 chp) const
+{
+	assert(m_collapser->get_criterion() == chpid);
+
+	int idx = find_index(((AggregationCollapser*)m_collapser)->get_reference_chpids(), chp);
+	assert(idx >= 0);
+
+	return idx;
+}
+
+int Frameset::get_by_devno(__u32 d) const
+{
+	assert(m_collapser->get_criterion() == devno);
+
+	int idx = find_index(((AggregationCollapser*)m_collapser)->get_reference_devnos(), d);
+	assert(idx >= 0);
+
+	return idx;
+}
+
+int Frameset::get_by_mp_mm(__u32 mp_mm) const
+{
+	assert(m_collapser->get_criterion() == multipath_device);
+
+	int idx = find_index(((AggregationCollapser*)m_collapser)->get_reference_mp_mms(), mp_mm);
+	assert(idx >= 0);
+
+	return idx;
+}
+
+int Frameset::get_by_mm(__u32 mm) const
+{
+	assert(m_collapser->get_criterion() == none
+	       || m_collapser->get_criterion() == all);
+
+	int idx = m_collapser->get_index(mm);
+	assert(idx >= 0);
+
+	return idx;
+}
+
+int Frameset::get_by_wwpn(__u64 w) const
+{
+	assert(m_collapser->get_criterion() == wwpn);
+
+	int idx = find_index(((AggregationCollapser*)m_collapser)->get_reference_wwpns(), w);
+	assert(idx >= 0);
+
+	return idx;
+}
+
+const struct adapter_utilization* Frameset::get_utilization_stat_by_host_id(
+	__u32 h_id) const
+{
+	for (vector<struct utilization_wrapper>::const_iterator i = m_util_stats.begin();
+	      i != m_util_stats.end(); ++i) {
+		if ((*i).counter && (*i).stat->adapter_no == h_id)
+			return (*i).stat;
+	}
+
+	return NULL;
+}
+
+const struct adapter_utilization* Frameset::get_utilization_stat_by_chpid(
+	__u32 chpid) const
+{
+	int idx = get_by_chpid(chpid);
+
+	assert(idx < (int)m_util_stats.size());
+
+	if (idx >= (int)m_util_stats.size())
+		return NULL;
+
+	return m_util_stats[idx].stat;
+}
+
+const struct ioerr_cnt* Frameset::get_ioerr_stat_by_chpid(__u32 chpid) const
+{
+	int idx = get_by_chpid(chpid);
+
+	assert(idx < (int)m_ioerr_stats.size());
+
+	if (idx >= (int)m_ioerr_stats.size())
+		return NULL;
+
+	return m_ioerr_stats[idx];
+}
+
+const struct blkiomon_stat* Frameset::get_blkiomon_stat_by_chpid(__u32 chpid) const
+{
+	int idx = get_by_chpid(chpid);
+
+	if (idx >= (int)m_blkiomon_stats.size())
+		return NULL;
+
+	return m_blkiomon_stats[idx];
+}
+
+const struct blkiomon_stat* Frameset::get_blkiomon_stat_by_devno(__u32 devno) const
+{
+	int idx = get_by_devno(devno);
+
+	if (idx >= (int)m_blkiomon_stats.size())
+		return NULL;
+
+	return m_blkiomon_stats[idx];
+}
+
+const struct blkiomon_stat* Frameset::get_blkiomon_stat_by_wwpn(__u64 wwpn) const
+{
+	int idx = get_by_wwpn(wwpn);
+
+	if (idx >= (int)m_blkiomon_stats.size())
+		return NULL;
+
+	return m_blkiomon_stats[idx];
+}
+
+const struct blkiomon_stat* Frameset::get_blkiomon_stat_by_mp_mm(__u32 mp_mm) const
+{
+	int idx = get_by_mp_mm(mp_mm);
+
+	if (idx >= (int)m_blkiomon_stats.size())
+		return NULL;
+
+	return m_blkiomon_stats[idx];
+}
+
+const struct blkiomon_stat* Frameset::get_blkiomon_stat_by_mm(__u32 mm) const
+{
+	int idx = get_by_mm(mm);
+
+	if (idx >= (int)m_blkiomon_stats.size())
+		return NULL;
+
+	return m_blkiomon_stats[idx];
+}
+
+const struct zfcpdd_dstat* Frameset::get_zfcpdd_stat_by_chpid(__u32 chpid) const
+{
+	int idx = get_by_chpid(chpid);
+
+	if (idx >= (int)m_zfcpdd_stats.size())
+		return NULL;
+
+	return m_zfcpdd_stats[idx].stat;
+}
+
+const struct zfcpdd_dstat* Frameset::get_zfcpdd_stat_by_devno(__u32 devno) const
+{
+	int idx = get_by_devno(devno);
+
+	if (idx >= (int)m_zfcpdd_stats.size())
+		return NULL;
+
+	return m_zfcpdd_stats[idx].stat;
+}
+
+const struct zfcpdd_dstat* Frameset::get_zfcpdd_stat_by_wwpn(__u64 wwpn) const
+{
+	int idx = get_by_wwpn(wwpn);
+
+	if (idx >= (int)m_zfcpdd_stats.size())
+		return NULL;
+
+	return m_zfcpdd_stats[idx].stat;
+}
+
+const struct zfcpdd_dstat* Frameset::get_zfcpdd_stat_by_mp_mm(__u32 mp_mm) const
+{
+	int idx = get_by_mp_mm(mp_mm);
+
+	if (idx >= (int)m_zfcpdd_stats.size())
+		return NULL;
+
+	return m_zfcpdd_stats[idx].stat;
+}
+
+const struct zfcpdd_dstat* Frameset::get_zfcpdd_stat_by_mm(__u32 mm) const
+{
+	int idx = get_by_mm(mm);
+
+	if (idx >= (int)m_zfcpdd_stats.size())
+		return NULL;
+
+	return m_zfcpdd_stats[idx].stat;
+}
+
+const struct adapter_utilization* Frameset::get_utilization_stat_by_devno(
+	__u32 subchnl) const
+{
+	int idx = get_by_devno(subchnl);
+
+	assert(idx < (int)m_util_stats.size());
+
+	if (idx >= (int)m_util_stats.size())
+		return NULL;
+
+	return m_util_stats[idx].stat;
+}
+
+const struct ioerr_cnt* Frameset::get_ioerr_stat_by_devno(
+	__u32 devno) const
+{
+	int idx = get_by_devno(devno);
+
+	assert(idx < (int)m_ioerr_stats.size());
+
+	if (idx >= (int)m_ioerr_stats.size())
+		return NULL;
+
+	return m_ioerr_stats[idx];
+}
+
+int Frameset::find_index(const list<__u32> &lst, __u32 val) const
+{
+	unsigned int idx = 0;
+
+	for (list<__u32>::const_iterator i = lst.begin();
+	      i != lst.end(); ++i, ++idx) {
+		if (*i == val)
+			return idx;
+	}
+
+	return -1;
+}
+
+int Frameset::find_index(const list<__u64> &lst, __u64 val) const
+{
+	unsigned int idx = 0;
+
+	for (list<__u64>::const_iterator i = lst.begin();
+	      i != lst.end(); ++i, ++idx) {
+		if (*i == val)
+			return idx;
+	}
+
+	return -1;
+}
+
+
+
+
+
Index: s390-tools-sles11/ziomon/ziorep_frameset.hpp
===================================================================
--- /dev/null
+++ s390-tools-sles11/ziomon/ziorep_frameset.hpp
@@ -0,0 +1,228 @@
+/*
+ * FCP report generators
+ *
+ * Class to hold information of a single frame.
+ *
+ * Copyright IBM Corp. 2008
+ * Author(s): Stefan Raspl <raspl@linux.vnet.ibm.com>
+ */
+
+#ifndef ZIOREP_FRAMESET
+#define ZIOREP_FRAMESET
+
+#include <list>
+#include <vector>
+
+#include "ziorep_collapser.hpp"
+
+extern "C" {
+	#include "ziomon_util.h"
+	#include "blkiomon.h"
+	#include "ziomon_zfcpdd.h"
+	#include "ziomon_dacc.h"
+}
+
+using std::list;
+using std::vector;
+
+class Frameset {
+
+public:
+	/**
+	 * If 'normalize' is set, incoming data with varying sample
+	 * sizes per interval (namely utilization messages and zfcpdd data)
+	 * will be normalized so that different sample sizes will not
+	 * result in different weighting when aggregating.
+	 */
+	Frameset(const Collapser *col, bool normalize = true);
+	~Frameset();
+
+	/**
+	 * Clear frame-related structures */
+	void reinit();
+
+	/// get pointer to collapser
+	const Collapser* get_collapser() const;
+
+	/**
+	 * Since we don't necessarily have datasets for all messages in each
+	 * frame, utilization and the qdio portion of zfcpdd messages
+	 * can be inaccurate when aggregated. This method makes up for it by
+	 * calculating how many datasets are expected and fixing the data so
+	 * that mean values (and minima!) correctly reflect the frames with
+	 * inactivity.
+	 * 'interval_length' is the length of the intervals in the source data,
+	 * NOT any user-specified interval!
+	 */
+	void replace_missing_datasets(int interval_length);
+
+	/**
+	 * Add structures to frame, automatically aggregates structures for
+	 * the same device if possible.
+	 */
+	void add_data(struct adapter_utilization *msg);
+	void add_data(struct ioerr_cnt *msg);
+	void add_data(struct blkiomon_stat *msg);
+	void add_data(struct zfcpdd_dstat *msg);
+
+	/**
+	 * Get start time of respective timeframe. This is the actually used
+	 * start time, which means that it is slightly earlier than the
+	 * expected start time so that messages that arrived slightly
+	 * earlier are included in this this rather than the previous frame. */
+	__u64 get_begin_time() const;
+
+	/**
+	* Get end time of respective timeframe. This is the actually used
+	* end time, which means that messages that arrived slightly
+	* later than the prediced end time might still have been included
+	* since they belong to this rather than to the next frame. */
+	__u64 get_end_time() const;
+
+	/* Get the timestamp of the frame. The timestamp
+	 * is the timestamp of the last message that was added to the frameset.
+	 */
+	__u64 get_timestamp() const;
+
+	/**
+	 * Get duration of respective timeframe */
+	__u64 get_duration() const;
+
+	/**
+	 * Set begin and end of the interval, as well as the predicted
+	 * timestamp of the last interval where all the messages should have
+	 * arrived */
+	void set_timeframe(__u64 begin, __u64 end, __u64 timestamp);
+
+	/** Retrieve ioerr result.
+	 * WARNING: Memory ownership remains in class - copy if necessary!
+	* FURTHER WARNING: Some of the pointers can be NULL!
+	 */
+	const vector<struct ioerr_cnt*>& get_ioerr_stats() const;
+
+	/** Retrieve zfcpdd result.
+	*  Can be NULL.
+	 */
+	const struct zfcpdd_dstat* get_first_zfcpdd_stat() const;
+
+	/** Retrieve blkiomon result.
+	 *  Can be NULL.
+	 */
+	const struct blkiomon_stat* get_first_blkiomon_stat() const;
+
+	const struct adapter_utilization* get_utilization_stat_by_host_id(__u32 h_id) const;
+
+	const struct adapter_utilization* get_utilization_stat_by_chpid(__u32 chpid) const;
+
+	const struct adapter_utilization* get_utilization_stat_by_devno(__u32 devno) const;
+
+	const struct ioerr_cnt* get_ioerr_stat_by_chpid(__u32 chpid) const;
+
+	const struct ioerr_cnt* get_ioerr_stat_by_devno(__u32 devno) const;
+
+	const struct blkiomon_stat* get_blkiomon_stat_by_chpid(__u32 chpid) const;
+
+	const struct blkiomon_stat* get_blkiomon_stat_by_devno(__u32 devno) const;
+
+	const struct blkiomon_stat* get_blkiomon_stat_by_wwpn(__u64 wwpn) const;
+
+	const struct blkiomon_stat* get_blkiomon_stat_by_mp_mm(__u32 mp_mm) const;
+
+	const struct blkiomon_stat* get_blkiomon_stat_by_mm(__u32 mm) const;
+
+	const struct zfcpdd_dstat* get_zfcpdd_stat_by_chpid(__u32 chpid) const;
+
+	const struct zfcpdd_dstat* get_zfcpdd_stat_by_devno(__u32 devno) const;
+
+	const struct zfcpdd_dstat* get_zfcpdd_stat_by_wwpn(__u64 wwpn) const;
+
+	const struct zfcpdd_dstat* get_zfcpdd_stat_by_mp_mm(__u32 mp_mm) const;
+
+	const struct zfcpdd_dstat* get_zfcpdd_stat_by_mm(__u32 mm) const;
+
+	void set_aggregated(bool aggr);
+
+	/** Is the frameset built from the .agg file? */
+	bool is_aggregated() const;
+
+	/** Query whether the frameset holds data or not */
+	bool is_empty() const;
+
+protected:
+	struct utilization_wrapper {
+		/// number aggregated datasets
+		int			 	 counter;
+		struct adapter_utilization	*stat;
+	};
+
+	struct zfcpdd_wrapper {
+		/// number aggregated datasets
+		int			 counter;
+		struct zfcpdd_dstat	*stat;
+	};
+
+private:
+	bool m_empty;
+
+	void normalize_util_stat(struct utilization_stats *stats);
+
+	void normalize_stat(struct abbrev_stat *stat, __u64 count);
+
+	/// rescale zfcpdd_dstat->channel_latency from ns to us
+	void normalize_zfcpdd_stat(struct zfcpdd_dstat *stat);
+
+	void init_utilization_wrapper(struct utilization_wrapper *wrp);
+
+	void init_zfcpdd_wrapper(struct zfcpdd_wrapper *wrp);
+
+	void add_zero_frames(struct utilization_wrapper *wrp,
+			     int num_expected, int interval_length);
+
+	int get_by_chpid(__u32 chpid) const;
+
+	int get_by_devno(__u32 devno) const;
+
+	int get_by_mp_mm(__u32 mp_mm) const;
+
+	int get_by_mm(__u32 mm) const;
+
+	int get_by_wwpn(__u64 wwpn) const;
+
+	/// returns index of 'val' as found in 'lst', <0 otherwise
+	int find_index(const list<__u32> &lst, __u32 val) const;
+
+	/// returns index of 'val' as found in 'lst', <0 otherwise
+	int find_index(const list<__u64> &lst, __u64 val) const;
+
+	/// zfcpdd statistics, ordered by host adapter no (ascending)
+	vector<struct utilization_wrapper>	m_util_stats;
+
+	/** ioerror stats, ordered by device identifiers
+	 * (hierarchical & ascending) */
+	vector<struct ioerr_cnt*>		m_ioerr_stats;
+
+	/// zfcpdd statistics, ordered by device (ascending)
+	vector<struct zfcpdd_wrapper>		m_zfcpdd_stats;
+	/// zfcpdd statistics, ordered by device (ascending)
+	vector<struct blkiomon_stat*>		m_blkiomon_stats;
+	/// begin of the frame
+	__u64					m_start_time;
+	/// end of the frame
+	__u64					m_end_time;
+	/// timestamp of latest message added to the set
+	__u64					m_timestamp;
+	/// indicates whether the frameset is from the .agg file
+	bool					m_aggregated;
+
+	/** provides translation from data objects to (vector) index
+	  * This member is kept throughout, even survives calls to reinit(). */
+	const Collapser			       *m_collapser;
+
+	/** normalize all incoming datasets so they are equally weighted
+	 * when aggregating over multiple frames */
+	bool					m_normalize;
+};
+
+
+#endif
+
